/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.db4ounit.common.assorted;


import com.db4o.*;
import com.db4o.ext.*;
import com.db4o.foundation.io.*;

import db4ounit.*;
import db4ounit.extensions.*;


public class PreventMultipleOpenTestCase extends AbstractDb4oTestCase {

	private static final String FILE = "PreventMultipleOpenTestCase.db4o"; 

	public static void main(String[] args) {
		new PreventMultipleOpenTestCase().runSolo();
	}
	
	
	protected void db4oCustomTearDown() throws Exception {
		File4.delete(FILE);
		super.db4oCustomTearDown();
	}


	public void testOpenTwice(){
		ObjectContainer oc = Db4o.openFile(FILE);
		Assert.expect(DatabaseFileLockedException.class, new CodeBlock() {
			public void run() throws Exception {
				Db4o.openFile(FILE);
			}
		});
		keepAlive(oc);
		oc.close();
	}
	
	public void testReopen(){
		ObjectContainer oc = Db4o.openFile(FILE);
		oc.close();
		oc = Db4o.openFile(FILE);
		Assert.isNotNull(oc);
		oc.close();
	}

	private void keepAlive(ObjectContainer oc) {}
}
